<template>
  <b-list-group-item class="d-flex justify-content-between align-items-center">
    <div class="d-flex justify-content-between align-items-center">
      <b-form-checkbox :id="'task_'+task.id" :name="'task_'+task.id" v-model="task.completed" @change="updateIsCompleted">
      </b-form-checkbox> 
<!-- disabled -->
      <b-button-group size="sm" class="mr-1">
        <b-button :disabled="!isDisabledUp" variant="light" @click="changeOrder('up')" v-b-popover.hover.top="'Mover para cima'">&#9650;</b-button>
        <b-button :disabled="!isDisabledDown" variant="light" @click="changeOrder('down')" v-b-popover.hover.top="'Mover para baixo'">&#9660;</b-button>
      </b-button-group>
    </div> 


    {{ task.description }}
    <b-badge variant="danger" @click="remove" pill>X</b-badge>
  </b-list-group-item>
</template>

<script>
export default {
  name: 'task',
  props: {
    task: {
      type: Object,
      required: true
    },
    index: {
      type: Number,
      default: 0
    },
    lastIndex: {
      type: Number,
      default: 0
    }
  },
  data() {
    return {

    }
  },
  methods: {
    remove() {
      this.$emit('remove', this.task.id);
    },
    updateIsCompleted() {
      this.$emit('updateIsCompleted', this.task);
    },
    changeOrder(to) {
      this.$emit('setPreloader', true);
      var targetIndex = to === 'up' ? this.index - 2 : this.index;
      this.$emit('changeOrder', this.task.order, targetIndex);
    }
  },
  computed: {
    isDisabledUp() {
      return this.index > 1;
    },
    isDisabledDown() {
      return this.index < this.lastIndex;
    }
  }
}
</script>

<style>
  .badge-danger {
    cursor: pointer;
  }
</style>
